#include <windows.h>
#include <stdio.h>
#include <math.h>
#include <commctrl.h>

#include <GdiPlus.h>
#include "setscrollbar_img.h"
#include "resource.h"

#pragma comment(lib, "GdiPlus.lib")
#pragma comment(lib, "comctl32.lib")

#define MYWNDCLASS	"kantagraph"
#define MYWNDTITLE	"kantagraph"
#define VERSION		"1.2"
#define DATA_NUM	512			// f[^
#define BOX_NUM		2			// J[{bNX
#define LINE_NUM	5			// ̐
#define DIV_Y_MAX	100			// Yڐ̍ő吔
#define STR_MAX		256			// obt@TCY

using namespace 	Gdiplus;
GdiplusStartupInput gdiSI;
ULONG_PTR			gdiToken;

Bitmap		*g_Bmp = NULL;
HINSTANCE	g_hInst = NULL;
HWND		g_hWnd = NULL;
HWND		g_hDlg = NULL;
HWND		g_hDialogbox1 = NULL;
HIMAGELIST	g_hIml = NULL;		// C[WXg̃nh
int 		g_idxBmp[LINE_NUM];	// C[WXg2̃C[W̔ԍ
COLORREF	g_color[BOX_NUM] = {RGB(255, 255, 255), RGB(0, 0, 0)};
POINT		g_pos = {10, 10};			// Ot̗]
bool		g_flag_transparent = true;	// ߃tO
bool		g_flag_autorate = false;	// 䗦vZtO
double		g_data[DATA_NUM];			// f[^l
int			g_num = 0;					// f[^
int			g_wdh = 0;					// 
int			g_hgt = 200;				// 
int			g_pen_size = 1;				// y̑
int         g_dot_size = 4;				// _̑傫
int			g_dot_shape = 0;			// _̌`
int			g_dot_x_interval = 20;		// Xڐ̊Ԋu
int			g_dush_style = 0;			// 
int			g_axis_div_len = 5;			// ڐ̒
int			g_axis_x_interval = 1;		// XڐԊu
int			g_y0 = g_pos.y;				// Y̌_W
int			g_show_type = 2;			// \i0:Ot̂݁A1:Ŵ݁A2:OtƍWj
double		g_value_min = 0;			// f[^̍ŏl
double		g_value_max = 0;			// f[^̍ől
double		g_rate = 1.0;				// k
double		g_axix_y_interval = 0;		// YڐP
char		g_filename[MAX_PATH] = "";

// ֐̃vg^Cv錾
LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
BOOL CALLBACK ProcDlg1(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
void Draw_Background(Graphics *g, Graphics *gBmp);
void Draw_Axis(Graphics *gBmp, int data_num);
void Draw_Graph(Graphics *gBmp, Color clr_line, int data_num);
void Set_Rate();
void Create_ImageList();
void Load_LineBmp(int idx, int idBmp);
void Fill_Rect(HDC hDC, UINT x, UINT y, UINT width, UINT height, COLORREF clr, bool flag_RopInvert);
void M_ButtonUpColorbox(HWND hDlg, HWND *hPic, LPARAM lParam);
RECT Get_ControlRect(HWND hDlg, HWND hCtrl);
void Open_ColorDlg(HWND hWnd, int index);
void Open_FileDlg();
void Save_FileDlg();
void Save_PNG(char *filename);
bool Load_File(char *filename);
bool Menu_Toggle_Check(HWND hWnd, UINT id);
void Menu_Check(HWND hWnd, UINT id, bool flag_check);
Status Draw_OutLine(Graphics *g, Rect rc, Color clr1, Color clr2);
int GetEncoderClsid(const WCHAR* format, CLSID* pClsid);

int APIENTRY WinMain(HINSTANCE hInst, HINSTANCE hInstPrev, LPSTR lpCmdLine, int nCmdShow)
{
	// dNh~&R}hCn
	HWND hWnd = FindWindow(MYWNDCLASS, MYWNDTITLE);
	if(hWnd){
		SetForegroundWindow(hWnd);
		COPYDATASTRUCT cds;
		ZeroMemory(&cds, sizeof(cds));
		cds.cbData = strlen(lpCmdLine)+1;
		cds.lpData = lpCmdLine;
		SendMessage(hWnd, WM_COPYDATA, NULL, (LPARAM)&cds);
		return 0;
	}
	
	MSG 	   msg;
	WNDCLASSEX wc;
	HMENU	   hMenu;
	
	g_hInst = hInst;

	// eEBhE
	ZeroMemory(&wc, sizeof(wc));
	wc.cbSize			= sizeof(WNDCLASSEX);
	wc.lpfnWndProc		= (WNDPROC)WndProc;
	wc.hInstance		= hInst;
	wc.hIcon			= LoadIcon(hInst, MAKEINTRESOURCE(IDI_ICON1));
	wc.hCursor			= LoadCursor(NULL, MAKEINTRESOURCE(IDC_ARROW));
	wc.hbrBackground	= (HBRUSH)(COLOR_BTNFACE + 1);
	wc.lpszMenuName 	= NULL;
	wc.lpszClassName	= MYWNDCLASS;
	RegisterClassEx(&wc);

	hMenu = LoadMenu(hInst, MAKEINTRESOURCE(IDR_MENU1));
	
	hWnd = CreateWindowEx(WS_EX_CLIENTEDGE | WS_EX_ACCEPTFILES,
				MYWNDCLASS,
				MYWNDTITLE,
				WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN | WS_VISIBLE,
				CW_USEDEFAULT, CW_USEDEFAULT, 640, 680,
				NULL,
				hMenu,
				hInst,
				NULL);

	while (GetMessage(&msg, NULL, 0, 0)) {
		if(g_hDlg){
			if(IsDialogMessage(g_hDlg, &msg))	continue;
		}
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}// WinMain

// C EBhẼvV[W
LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_CREATE:
		// R Rg[iXsEgR{j
		INITCOMMONCONTROLSEX	icex;
		icex.dwSize = sizeof(INITCOMMONCONTROLSEX);
		icex.dwICC  = ICC_UPDOWN_CLASS | ICC_USEREX_CLASSES;
		InitCommonControlsEx(&icex);
		// C[W Xg쐬
		Create_ImageList();
		// fch{
		GdiplusStartup(&gdiToken, &gdiSI, NULL);
		// XN[ o[
		Set_ScrollBar(hWnd);
		Set_Scroll_nMax(hWnd, g_wdh, g_hgt);
		// _CAO {bNX쐬
		g_hDialogbox1 = CreateDialog(g_hInst, MAKEINTRESOURCE(IDD_DIALOG1), hWnd, ProcDlg1);
		// EBhE nhOϐɓ
		g_hWnd = hWnd;
		// R}hCƂ
		if(__argc > 1){
			Load_File(__argv[1]);
			InvalidateRect(hWnd, NULL, TRUE);
		}
		return 0;
	case WM_SIZE:
		Set_Scroll_nPage(hWnd);
		return 0;
	case WM_HSCROLL:
		Move_Scroll_H(hWnd, wParam);
		return 0;
	case WM_VSCROLL:
		Move_Scroll_V(hWnd, wParam);
		return 0;
	case WM_COPYDATA:
		{
			COPYDATASTRUCT *pcds;
			pcds = (COPYDATASTRUCT*) lParam;
			Load_File((char*)pcds->lpData);
			InvalidateRect(hWnd, NULL, TRUE);
		}
		return 0;
	case WM_DROPFILES:
		{
			HDROP	hDrop;
			hDrop = (HDROP) wParam;
			int r = DragQueryFile(hDrop, (UINT)-1, NULL, 0);
			if(r > 0){
				char filename[MAX_PATH];
				DragQueryFile(hDrop, 0, filename, sizeof(filename));
				Load_File(filename);
				InvalidateRect(hWnd, NULL, TRUE);
			}
			DragFinish(hDrop);
		}
		return 0;
	case WM_COMMAND:
		switch( LOWORD(wParam) )
		{
		case IDM_OPEN:
			Open_FileDlg();
			InvalidateRect(hWnd, NULL, TRUE);
			break;
		case IDM_SAVEAS:
			Save_FileDlg();
			break;
		case IDM_EXIT:
			SendMessage(hWnd, WM_CLOSE, 0, 0);
			break;
		
		case IDM_SHOW_TOOL:
			if(IsWindowVisible(g_hDialogbox1)){
				Menu_Check(hWnd, IDM_SHOW_TOOL, false);
				ShowWindow(g_hDialogbox1, SW_HIDE);
			}
			else{
				Menu_Check(hWnd, IDM_SHOW_TOOL, true);
				ShowWindow(g_hDialogbox1, SW_SHOW);
			}
			break;
		case IDM_ABOUT:	// o[W
			{
			char strVer[256];
			_snprintf(strVer, sizeof(strVer), "%s ver %s\tPGM", MYWNDTITLE, VERSION);
			ShellAbout(hWnd, MYWNDTITLE, strVer, LoadIcon(g_hInst,MAKEINTRESOURCE(IDI_ICON1)));
			}
			break;
		}
		return 0;
	case WM_PAINT:
		{
			HDC				hDC;
			PAINTSTRUCT 	ps;
			hDC = BeginPaint(hWnd, &ps);
			// rbg}bv IuWFNg폜
			if(g_Bmp){
				delete  g_Bmp;
				g_Bmp = NULL;
			}
			// rbg}bv IuWFNg쐬
			g_Bmp = new Bitmap(g_wdh, g_hgt, PixelFormat32bppARGB);
			// HDC`IuWFNg쐬
			Graphics	g(hDC);
			// rbg}bv`IuWFNg쐬
			Graphics	gBmp(g_Bmp);
			// f[^
			int			data_num = min(g_num, g_wdh / g_dot_x_interval);
			// NbsO
			gBmp.SetClip(Rect(0, 0, g_wdh, g_hgt));
			// wi`
			Draw_Background(&g, &gBmp);
			// X[WOݒ
			gBmp.SetSmoothingMode(SmoothingModeAntiAlias);
			// W`
			if(g_show_type != 0){
				Draw_Axis(&gBmp, data_num);
			}
			// Ot`
			if(g_show_type != 1){
				Color		clr_line;
				clr_line.SetFromCOLORREF(g_color[1]);
				Draw_Graph(&gBmp, clr_line, data_num);
			}
			// HDC Ƀrbg}bv`
			g.DrawImage(g_Bmp, 0, 0, g_wdh, g_hgt);
			// `I
			EndPaint(hWnd, &ps);
		}
		return 0;
	case WM_CLOSE:
		if(g_hIml){
			ImageList_Destroy(g_hIml);
		}
		if(g_Bmp){
			delete  g_Bmp;
			g_Bmp = NULL;
		}
		DestroyWindow(hWnd);
		GdiplusShutdown(gdiToken);
		PostQuitMessage(0);
		return 0;
	}
	return DefWindowProc(hWnd, uMsg, wParam, lParam);
}// WndProc

// _CAO{bNX̃vV[W
BOOL CALLBACK ProcDlg1(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	static HWND hEdit[10];		// GfBbg
	static HWND hSlider[2];		// XC_[
	static HWND hPic[BOX_NUM];	// J[{bNX
	static HWND hCombEx;		// gR{{bNX
	static char str[STR_MAX];
	const  int  line_size = 16;

	switch(uMsg)
	{
	case WM_INITDIALOG:
		{
			int i;
			
			hPic[0]    = GetDlgItem(hDlg, IDC_STATIC1);
			hPic[1]    = GetDlgItem(hDlg, IDC_STATIC2);
			hEdit[0]   = GetDlgItem(hDlg, IDC_EDIT1);
			hEdit[1]   = GetDlgItem(hDlg, IDC_EDIT2);
			hEdit[2]   = GetDlgItem(hDlg, IDC_EDIT3);
			hEdit[3]   = GetDlgItem(hDlg, IDC_EDIT4);
			hEdit[4]   = GetDlgItem(hDlg, IDC_EDIT5);
			hEdit[5]   = GetDlgItem(hDlg, IDC_EDIT6);
			hEdit[6]   = GetDlgItem(hDlg, IDC_EDIT7);
			hEdit[7]   = GetDlgItem(hDlg, IDC_EDIT8);
			hEdit[8]   = GetDlgItem(hDlg, IDC_EDIT9);
			hEdit[9]   = GetDlgItem(hDlg, IDC_EDIT10);
			hSlider[0] = GetDlgItem(hDlg, IDC_SLIDER1);
			hSlider[1] = GetDlgItem(hDlg, IDC_SLIDER2);
			hCombEx    = GetDlgItem(hDlg, IDC_COMBOBOXEX1);
			
			for(i=0; i<8 ;i++){
				SendMessage(hEdit[i], EM_SETLIMITTEXT, 4, 0);
			}
			for(i=8; i<10 ;i++){
				SendMessage(hEdit[i], EM_SETLIMITTEXT, strlen(str)-1, 0);
			}
			sprintf(str, "%g", g_axix_y_interval);
			SendMessage(hEdit[8], WM_SETTEXT, 0, (LPARAM) str);
			SendDlgItemMessage(hDlg, IDC_SPIN1, UDM_SETRANGE, 0, MAKELONG(1280, 0));
			SendDlgItemMessage(hDlg, IDC_SPIN2, UDM_SETRANGE, 0, MAKELONG(1280, 0));
			SendDlgItemMessage(hDlg, IDC_SPIN3, UDM_SETRANGE, 0, MAKELONG(256, 0));
			SendDlgItemMessage(hDlg, IDC_SPIN4, UDM_SETRANGE, 0, MAKELONG(256, 0));
			SendDlgItemMessage(hDlg, IDC_SPIN5, UDM_SETRANGE, 0, MAKELONG(100, 1));
			SendDlgItemMessage(hDlg, IDC_SPIN6, UDM_SETRANGE, 0, MAKELONG(100, 0));
			SendDlgItemMessage(hDlg, IDC_SPIN7, UDM_SETRANGE, 0, MAKELONG(256, 1));
			SendDlgItemMessage(hDlg, IDC_SPIN8, UDM_SETRANGE, 0, MAKELONG(100, 0));
			SendDlgItemMessage(hDlg, IDC_SPIN1, UDM_SETPOS, 0, MAKELONG(g_wdh, 0));
			SendDlgItemMessage(hDlg, IDC_SPIN2, UDM_SETPOS, 0, MAKELONG(g_hgt, 0));
			SendDlgItemMessage(hDlg, IDC_SPIN3, UDM_SETPOS, 0, MAKELONG(g_pos.x, 0));
			SendDlgItemMessage(hDlg, IDC_SPIN4, UDM_SETPOS, 0, MAKELONG(g_pos.y, 0));
			SendDlgItemMessage(hDlg, IDC_SPIN5, UDM_SETPOS, 0, MAKELONG(g_pen_size, 0));
			SendDlgItemMessage(hDlg, IDC_SPIN6, UDM_SETPOS, 0, MAKELONG(g_dot_size, 0));
			SendDlgItemMessage(hDlg, IDC_SPIN7, UDM_SETPOS, 0, MAKELONG(g_dot_x_interval, 0));
			SendDlgItemMessage(hDlg, IDC_SPIN8, UDM_SETPOS, 0, MAKELONG(g_axis_x_interval, 0));
			for(i=0; i<2 ;i++){
				SendMessage(hSlider[i], TBM_SETLINESIZE, 0, line_size);
			}
			SendMessage(hSlider[0], TBM_SETRANGE, TRUE, MAKELONG(1, 1280));
			SendMessage(hSlider[1], TBM_SETRANGE, TRUE, MAKELONG(1, 1280));
			SendMessage(hSlider[0], TBM_SETPOS, TRUE, g_wdh);
			SendMessage(hSlider[1], TBM_SETPOS, TRUE, g_hgt);

			// gR{{bNX
			COMBOBOXEXITEM cbei;
			ZeroMemory(&cbei, sizeof(cbei));
			cbei.mask = CBEIF_IMAGE | CBEIF_SELECTEDIMAGE;
			for(i=0;i<LINE_NUM;i++){
				cbei.iItem			= i;
				cbei.iImage 		= g_idxBmp[i];
				cbei.iSelectedImage = g_idxBmp[i];
				SendMessage(hCombEx, CBEM_INSERTITEM, 0, (LPARAM) &cbei);
			}
			SendMessage(hCombEx, CBEM_SETIMAGELIST, 0, (LPARAM) g_hIml);
			SendMessage(hCombEx, CB_SETCURSEL, g_dush_style, 0);
			// R{{bNX
			SendDlgItemMessage(hDlg, IDC_COMBO1, CB_ADDSTRING, 0, (LPARAM)"");
			SendDlgItemMessage(hDlg, IDC_COMBO1, CB_ADDSTRING, 0, (LPARAM)"");
			SendDlgItemMessage(hDlg, IDC_COMBO1, CB_SETCURSEL, g_dot_shape, 0);
			SendDlgItemMessage(hDlg, IDC_COMBO2, CB_ADDSTRING, 0, (LPARAM)"Ot̂");
			SendDlgItemMessage(hDlg, IDC_COMBO2, CB_ADDSTRING, 0, (LPARAM)"Ŵ");
			SendDlgItemMessage(hDlg, IDC_COMBO2, CB_ADDSTRING, 0, (LPARAM)"OtƍW");
			SendDlgItemMessage(hDlg, IDC_COMBO2, CB_SETCURSEL, g_show_type, 0);
			// `FbN{bNX
			if(g_flag_transparent){
				SendDlgItemMessage(hDlg, IDC_CHECK1, BM_SETCHECK, BST_CHECKED, 0);
			}
			if(g_flag_autorate){
				SendDlgItemMessage(hDlg, IDC_CHECK2, BM_SETCHECK, BST_CHECKED, 0);
				EnableWindow(hEdit[9], FALSE);
			}
		}
		break;
	case WM_ACTIVATE:
		if(wParam)	g_hDlg = hDlg;
		else		g_hDlg = NULL;
		break;
	case WM_LBUTTONUP:
		M_ButtonUpColorbox(hDlg, hPic, lParam);
		break;
	case WM_PAINT:
		{
			// J[{bNX`
			HDC hDC;
			PAINTSTRUCT ps;
			hDC = BeginPaint(hDlg, &ps);
			RECT rc[BOX_NUM];
			int i;
			for(i=0;i<BOX_NUM;i++){
				rc[i] = Get_ControlRect(hDlg, hPic[i]);
				rc[i].right -= rc[i].left;
				rc[i].bottom -= rc[i].top;
				Fill_Rect(hDC, rc[i].left, rc[i].top, rc[i].right, rc[i].bottom, g_color[i], false);
			}
			EndPaint(hDlg, &ps);
		}
		break;
	case WM_COMMAND:
		switch( wParam )
		{
		case IDC_EDIT1 | (EN_CHANGE << 16):
			if(IsWindow(g_hWnd)){
				SendMessage(hEdit[0], WM_GETTEXT, sizeof(str), (LPARAM) str);
				g_wdh = atoi(str);
				if(hEdit[0] == GetFocus()){
					SendMessage(hSlider[0], TBM_SETPOS, true, g_wdh);
				}
				Set_Scroll_nMax(g_hWnd, g_wdh, g_hgt);
				InvalidateRect(g_hWnd, NULL, TRUE);
			}
			break;
		case IDC_EDIT2 | (EN_CHANGE << 16):
			if(IsWindow(g_hWnd)){
				SendMessage(hEdit[1], WM_GETTEXT, sizeof(str), (LPARAM) str);
				g_hgt = atoi(str);
				if(hEdit[1] == GetFocus()){
					SendMessage(hSlider[1], TBM_SETPOS, true, g_hgt);
				}
				Set_Rate();
				Set_Scroll_nMax(g_hWnd, g_wdh, g_hgt);
				InvalidateRect(g_hWnd, NULL, TRUE);
			}
			break;
		case IDC_EDIT3 | (EN_CHANGE << 16):
			if(IsWindow(g_hWnd)){
				SendMessage(hEdit[2], WM_GETTEXT, sizeof(str), (LPARAM) str);
				g_pos.x = atoi(str);
				InvalidateRect(g_hWnd, NULL, TRUE);
			}
			break;
		case IDC_EDIT4 | (EN_CHANGE << 16):
			if(IsWindow(g_hWnd)){
				SendMessage(hEdit[3], WM_GETTEXT, sizeof(str), (LPARAM) str);
				g_pos.y = atoi(str);
				Set_Rate();
				InvalidateRect(g_hWnd, NULL, TRUE);
			}
			break;
		case IDC_EDIT5 | (EN_CHANGE << 16):
			if(IsWindow(g_hWnd)){
				SendMessage(hEdit[4], WM_GETTEXT, sizeof(str), (LPARAM) str);
				g_pen_size = atoi(str);
				InvalidateRect(g_hWnd, NULL, TRUE);
			}
			break;
		case IDC_EDIT6 | (EN_CHANGE << 16):
			if(IsWindow(g_hWnd)){
				SendMessage(hEdit[5], WM_GETTEXT, sizeof(str), (LPARAM) str);
				g_dot_size = atoi(str);
				InvalidateRect(g_hWnd, NULL, TRUE);
			}
			break;
		case IDC_EDIT7 | (EN_CHANGE << 16):
			if(IsWindow(g_hWnd)){
				SendMessage(hEdit[6], WM_GETTEXT, sizeof(str), (LPARAM) str);
				g_dot_x_interval = atoi(str);
				InvalidateRect(g_hWnd, NULL, TRUE);
			}
			break;
		case IDC_EDIT8 | (EN_CHANGE << 16):
			if(IsWindow(g_hWnd)){
				SendMessage(hEdit[7], WM_GETTEXT, sizeof(str), (LPARAM) str);
				g_axis_x_interval = atoi(str);
				InvalidateRect(g_hWnd, NULL, TRUE);
			}
			break;
		case IDC_EDIT9 | (EN_CHANGE << 16):
			if(IsWindow(g_hWnd)){
				SendMessage(hEdit[8], WM_GETTEXT, sizeof(str), (LPARAM) str);
				g_axix_y_interval = atof(str);
				InvalidateRect(g_hWnd, NULL, TRUE);
			}
			break;
		case IDC_EDIT10 | (EN_CHANGE << 16):
			if(IsWindow(g_hWnd)){
				SendMessage(hEdit[9], WM_GETTEXT, sizeof(str), (LPARAM) str);
				g_rate = atof(str);
				InvalidateRect(g_hWnd, NULL, TRUE);
			}
			break;
		case IDC_COMBOBOXEX1 | (CBN_SELCHANGE << 16):
			{
				g_dush_style = SendMessage(hCombEx, CB_GETCURSEL, 0, 0);
				InvalidateRect(g_hWnd, NULL, TRUE);
			}
			break;
		case IDC_COMBO1 | (CBN_SELCHANGE<<16):
			{
				g_dot_shape = SendDlgItemMessage(hDlg, IDC_COMBO1, CB_GETCURSEL, 0, 0);
				InvalidateRect(g_hWnd, NULL, TRUE);
			}
			break;
		case IDC_COMBO2 | (CBN_SELCHANGE<<16):
			{
				g_show_type = SendDlgItemMessage(hDlg, IDC_COMBO2, CB_GETCURSEL, 0, 0);
				InvalidateRect(g_hWnd, NULL, TRUE);
			}
			break;
		case IDC_CHECK1 | (BN_CLICKED<<16):
			if(BST_CHECKED == SendDlgItemMessage(hDlg, IDC_CHECK1, BM_GETCHECK, 0, 0)){
				g_flag_transparent = true;
			}
			else{
				g_flag_transparent = false;
			}
			InvalidateRect(g_hWnd, NULL, TRUE);
			break;
		case IDC_CHECK2 | (BN_CLICKED<<16):
			if(BST_CHECKED == SendDlgItemMessage(hDlg, IDC_CHECK2, BM_GETCHECK, 0, 0)){
				g_flag_autorate = true;
				Set_Rate();
				sprintf(str, "%g", g_rate);
				SendMessage(hEdit[9], WM_SETTEXT, 0, (LPARAM) str);
				EnableWindow(hEdit[9], FALSE);
				InvalidateRect(g_hWnd, NULL, TRUE);
			}
			else{
				g_flag_autorate = false;
				EnableWindow(hEdit[9], TRUE);
			}
			break;
		default:
			return FALSE;
		}
		break;
	case WM_NOTIFY:
		NMHDR *phdr;
		phdr = (NMHDR *)lParam;
		switch(phdr->code)
		{
		case UDN_DELTAPOS:	// Xs̃{^ꂽƂ
			LPNMUPDOWN	lpnmud;
			lpnmud = (LPNMUPDOWN) lParam;
			int pos = lpnmud->iPos;
			switch (lpnmud->hdr.idFrom)
			{
			case IDC_SPIN1:
				SendMessage(hSlider[0],TBM_SETPOS,TRUE,pos);
				break;
			case IDC_SPIN2:
				SendMessage(hSlider[1],TBM_SETPOS,TRUE,pos);
				break;
			}
		}
		break;
	case WM_HSCROLL:	// XC_[Ƃ
		{
			HWND	hSldr1 = (HWND) lParam;
			ULONG	dl = SendMessage(hSldr1,TBM_GETPOS,0,0);
			dl -= dl % line_size;
			SendMessage(hSldr1,TBM_SETPOS,TRUE,dl);
			if(hSldr1 == hSlider[0]){
				SendDlgItemMessage(hDlg,IDC_SPIN1,UDM_SETPOS,0,MAKELONG(dl,0));
			}
			else if(hSldr1 == hSlider[1]){
				SendDlgItemMessage(hDlg,IDC_SPIN2,UDM_SETPOS,0,MAKELONG(dl,0));
			}
		}
		break;
	case WM_CLOSE:
		ShowWindow(g_hDialogbox1, SW_HIDE);
		Menu_Check(g_hWnd, IDM_SHOW_TOOL, false);
		break;
	case WM_DESTROY:
		g_hDialogbox1 = NULL;
		break;
	default:
		return false;
	}
	return true;
}// ProcDlg1

// wi`
void Draw_Background(Graphics *g, Graphics *gBmp)
{
	if(g_flag_transparent){
		gBmp->Clear(Color(0,0,0,0));
		Rect rcOutLine(0, 0, g_wdh - 1, g_hgt - 1);
		Draw_OutLine(g, rcOutLine, Color(0,255,0), Color(0,0,0));
	}
	else{
		Color clr_back;
		clr_back.SetFromCOLORREF(g_color[0]);
		gBmp->Clear(clr_back);
	}
}// Draw_Background

// W̕`
void Draw_Axis(Graphics *gBmp, int data_num)
{
	Pen pen(Color(0,0,0), 1);
	int hgt = g_hgt - g_y0 - scr_y;
	gBmp->DrawLine(&pen, 0 - scr_x, hgt, g_wdh - scr_x, hgt);
	if(g_value_min >= 0){
		gBmp->DrawLine(&pen, 0 - scr_x, 0 - scr_y, 0 - scr_x, g_hgt - g_y0 - scr_y);
	}
	else{
		gBmp->DrawLine(&pen, 0 - scr_x, 0 - scr_y, 0 - scr_x, g_hgt - 1 - scr_y);
	}
	int i;
	if(g_axis_x_interval > 0){
		for(i=0; i<data_num; i+=g_axis_x_interval){
			int x = g_pos.x + i * g_dot_x_interval;
			gBmp->DrawLine(&pen, x - scr_x, hgt - g_axis_div_len, x - scr_x, hgt);
		}
	}
	double y_interval = g_axix_y_interval * g_rate;
	if(y_interval >= 2){
		int y_num = (int)((g_hgt - g_y0) / y_interval);
		if(y_num <= DIV_Y_MAX){
			for(i=0; i<y_num; i++){
				int y = (int)((i + 1) * y_interval);
				gBmp->DrawLine(&pen, 0 - scr_x, hgt - y, g_axis_div_len - scr_x, hgt - y);
			}
		}
		if(g_value_min < 0){
			y_num = (int)(g_y0 / y_interval);
			if(y_num <= DIV_Y_MAX){
				for(i=0; i<y_num; i++){
					int y = (int)((i + 1) * y_interval);
					gBmp->DrawLine(&pen, 0 - scr_x, hgt + y, g_axis_div_len - scr_x, hgt + y);
				}
			}
		}
	}
}// Draw_Axis

// Ot̕`
void Draw_Graph(Graphics *gBmp, Color clr_line, int data_num)
{
	Pen			pen(clr_line, (float) g_pen_size);
	SolidBrush	brush(clr_line);
	Point		pt[DATA_NUM];
	int			x;
	
	for(x=0; x<data_num; x++){
		pt[x].X = x * g_dot_x_interval + g_pos.x - scr_x;
		pt[x].Y = g_hgt - (int) (g_data[x] * g_rate) - g_y0 - scr_y;
		if(g_dot_shape == 0){
			gBmp->FillEllipse(&brush, pt[x].X - g_dot_size / 2, pt[x].Y - g_dot_size / 2, g_dot_size, g_dot_size);
		}
		else{
			gBmp->FillRectangle(&brush, pt[x].X - g_dot_size / 2, pt[x].Y - g_dot_size / 2, g_dot_size, g_dot_size);
		}
	}
	pen.SetDashStyle((DashStyle)(DashStyleSolid+g_dush_style));
	pen.SetDashCap((DashCap)(DashCapFlat + 2));
	pen.SetLineJoin((LineJoin)(LineJoinMiter + 2));
	gBmp->DrawLines(&pen, pt, data_num);
}// Draw_Graph

// ̕\䗦ݒ
void Set_Rate()
{
	if(g_flag_autorate){
		if(g_value_min >= 0){
			g_rate = (double) (g_hgt - g_pos.y * 2) / g_value_max;
			g_y0 = g_pos.y;
		}
		else{
			g_rate = (double) (g_hgt - g_pos.y * 2) / (g_value_max - g_value_min);
			g_y0 = -(int)(g_value_min * g_rate) + g_pos.y;
		}
	}
	char str[STR_MAX];
	sprintf(str, "%g", g_rate);
	SendDlgItemMessage(g_hDialogbox1, IDC_EDIT10, WM_SETTEXT, 0, (LPARAM) str);
}// Set_Rate

// C[WXg̍쐬
void Create_ImageList()
{
	g_hIml = ImageList_Create(64, 16, ILC_COLOR24, 0, 0);
	
	Load_LineBmp(0, IDB_LINE1);
	Load_LineBmp(1, IDB_LINE2);
	Load_LineBmp(2, IDB_LINE3);
	Load_LineBmp(3, IDB_LINE4);
	Load_LineBmp(4, IDB_LINE5);
}// Create_ImageList

// 摜ǂݍ
void Load_LineBmp(int idx, int idBmp)
{
	HBITMAP hBmp;
	
	hBmp = LoadBitmap(g_hInst, MAKEINTRESOURCE(idBmp));
	g_idxBmp[idx] = ImageList_Add(g_hIml, hBmp, NULL);
	DeleteObject((HGDIOBJ)hBmp);
}// Load_LineBmp

// `̓hׂ
void Fill_Rect(HDC hDC, UINT x, UINT y, UINT width, UINT height, COLORREF clr, bool flag_RopInvert)
{
	DWORD dwRop = PATCOPY;
	if(flag_RopInvert){
		dwRop = DSTINVERT;
	}
	HBRUSH hbr, hbrOld;
	hbr = CreateSolidBrush(clr);
	hbrOld = (HBRUSH) SelectObject(hDC, hbr);
	PatBlt(hDC, x, y, width, height, dwRop);
	SelectObject(hDC, hbrOld);
	DeleteObject(hbr);
}// Fill_Rect

void M_ButtonUpColorbox(HWND hDlg, HWND *hPic, LPARAM lParam)
{
	POINT	pt;
	int		i;
	pt.x = LOWORD(lParam);
	pt.y = HIWORD(lParam);
	RECT rc[BOX_NUM];
	for(i=0;i<BOX_NUM;i++){
		rc[i] = Get_ControlRect(hDlg, hPic[i]);
		if(PtInRect(&rc[i], pt)){
			Open_ColorDlg(hDlg, i);
			if(i == 0){
				g_flag_transparent = false;
				SendDlgItemMessage(hDlg, IDC_CHECK1, BM_SETCHECK, BST_UNCHECKED, 0);
			}
			InvalidateRect(hDlg, &rc[i], TRUE);
			InvalidateRect(g_hWnd, NULL, TRUE);
		}
	}
}// M_ButtonUpColorbox

// Rg[̃NCAgWԂ
RECT Get_ControlRect(HWND hDlg, HWND hCtrl)
{
	RECT rcSrc,rcDst;
	POINT pt;
	GetWindowRect(hCtrl, &rcSrc);
	rcDst.right  = rcSrc.right - rcSrc.left;
	rcDst.bottom = rcSrc.bottom - rcSrc.top;
	pt.x = rcSrc.left;
	pt.y = rcSrc.top;
	ScreenToClient(hDlg, &pt);
	rcDst.left = pt.x;
	rcDst.top  = pt.y;
	rcDst.right  += rcDst.left;
	rcDst.bottom += rcDst.top;
	return rcDst;
}// Get_ControlRect

// J[_CAO
void Open_ColorDlg(HWND hWnd, int index)
{
	if(index < 0 || index >= BOX_NUM){
		return;
	}
	static COLORREF CustColors[16] = {
						RGB(255, 255, 255), RGB(255, 255, 255),
						RGB(255, 255, 255), RGB(255, 255, 255),
						RGB(255, 255, 255), RGB(255, 255, 255),
						RGB(255, 255, 255), RGB(255, 255, 255),
						RGB(255, 255, 255), RGB(255, 255, 255),
						RGB(255, 255, 255), RGB(255, 255, 255),
						RGB(255, 255, 255), RGB(255, 255, 255),
						RGB(255, 255, 255), RGB(255, 255, 255)
					};
	CHOOSECOLOR	cc;
	ZeroMemory(&cc, sizeof(cc));
	cc.lStructSize = sizeof(CHOOSECOLOR);
	cc.hwndOwner = hWnd;
	cc.rgbResult = g_color[index];
	cc.lpCustColors = CustColors;
	cc.Flags = CC_RGBINIT;
	if(ChooseColor(&cc)){
		g_color[index] = cc.rgbResult;
	}
}// Open_ColorDlg

// I[v t@C _CAO
void Open_FileDlg()
{
	OPENFILENAME	ofn;
	char			fn[MAX_PATH];
	int				r;

	fn[0] = '\0';
	ZeroMemory(&ofn, sizeof(ofn));
	ofn.lStructSize = sizeof(ofn);
	ofn.hwndOwner = NULL;
	ofn.Flags = 0;
	ofn.Flags |= OFN_HIDEREADONLY; 
	ofn.lpstrFile = fn;
	ofn.nMaxFile = sizeof(fn);
	ofn.lpstrFilter = "eLXgt@C (*.txt)\0" "*.txt\0";
	ofn.nFilterIndex = 1;
	r = GetOpenFileName(&ofn);
	if (r) {
		Load_File(fn);
	}
}// Open_FileDlg

// ۑt@C_CAO
void Save_FileDlg()
{
	OPENFILENAME	ofn;
	char			fn[MAX_PATH];
	
	strcpy(fn, g_filename);
	
	ZeroMemory(&ofn, sizeof(OPENFILENAME));
	ofn.lStructSize  = sizeof(OPENFILENAME);
	ofn.hwndOwner    = g_hWnd;
	ofn.Flags        = OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT | OFN_EXTENSIONDIFFERENT;
	ofn.lpstrFile    = fn;
	ofn.lpstrDefExt  = "png";
	ofn.nMaxFile     = sizeof(fn);
	ofn.lpstrFilter =	"PNG (*.png)\0" "*.png\0" 
						"ׂẴt@C (*.*)\0" "*.*\0";
	ofn.nFilterIndex = 1;
	if(GetSaveFileName(&ofn)){
		Save_PNG(fn);
	}
}// Save_FileDlg

// PNGɕۑ
void Save_PNG(char *filename)
{
	WCHAR				wsfname[MAX_PATH];
	CLSID				Clsid;
	EncoderParameters	ecps;
	ULONG				bpp = 32;
	ecps.Count = 1;
	ecps.Parameter[0].Guid = EncoderColorDepth;
	ecps.Parameter[0].Type = EncoderParameterValueTypeLong;
	ecps.Parameter[0].NumberOfValues = 1;
	ecps.Parameter[0].Value = &bpp;
	GetEncoderClsid(L"image/png", &Clsid);
	MultiByteToWideChar(CP_ACP, 0, filename, -1, wsfname, sizeof(wsfname));
	g_Bmp->Save(wsfname, &Clsid, &ecps);
}// Save_PNG

// t@Cǂݍ
bool Load_File(char *filename)
{
	FILE	*fp;
	char	buf[256];

	if((fp=fopen(filename, "r")) == NULL){
		return 0;		
	}
	
	g_num = 0;
	
	while(!feof(fp)){
		if(fgets(buf, 256, fp)){
			if(buf[strlen(buf)-1] == '\n'){
				buf[strlen(buf)-1] = '\0';
			}
			g_data[g_num] = atof(buf);
			if(g_num == 0){
				g_value_min = g_value_max = g_data[g_num];
			}
			else{
				if(g_value_min > g_data[g_num]){
					g_value_min = g_data[g_num];
				}
				else if(g_value_max < g_data[g_num]){
					g_value_max = g_data[g_num];
				}
			}
			if(strlen(buf) > 0){
				g_num ++;
			}
			if(g_num >= DATA_NUM){
				break;
			}
		}
	}
	
	if(fclose(fp))
		return 0;
	
	// ݒ
	g_wdh = g_dot_x_interval * g_num + g_pos.x;
	SendDlgItemMessage(g_hDialogbox1, IDC_SPIN1, UDM_SETPOS, 0, MAKELONG(g_wdh, 0));
	SendDlgItemMessage(g_hDialogbox1, IDC_SLIDER1, TBM_SETPOS, TRUE, g_wdh);
	// ̕\䗦ݒ
	Set_Rate();
	// _CAO {bNX\
	ShowWindow(g_hDialogbox1, SW_SHOW);
	Menu_Check(g_hWnd, IDM_SHOW_TOOL, true);

	return 1;
}// Load_File

// j[̃`FbNύX
bool Menu_Toggle_Check(HWND hWnd, UINT id)
{
	MENUITEMINFO    mi;
	
	ZeroMemory (&mi, sizeof(mi));
	mi.cbSize = sizeof(mi);
	mi.fMask = MIIM_STATE;
	
	HMENU hMenu = GetMenu(hWnd);
	GetMenuItemInfo(hMenu, id, 0, &mi);
	
	if(mi.fState == MFS_UNCHECKED)
		mi.fState = MFS_CHECKED;
	else
		mi.fState = MFS_UNCHECKED;
	
	SetMenuItemInfo(hMenu, id, 0, &mi);
	
	if(mi.fState == MFS_CHECKED)
		return true;
	return false;
}// Menu_Toggle_Check

// j[ACe`FbNi܂͊Oj
void Menu_Check(HWND hWnd, UINT id, bool flag_check)
{
	MENUITEMINFO    mi;
	ZeroMemory (&mi, sizeof(mi));
	mi.cbSize = sizeof(mi);
	mi.fMask = MIIM_STATE;
	if(flag_check)
		mi.fState = MFS_CHECKED;
	else
		mi.fState = MFS_UNCHECKED;
	
	SetMenuItemInfo(GetMenu(hWnd), id, 0, &mi);
}// Menu_Check

// 摜̊Og̕`
Status Draw_OutLine(Graphics *g, Rect rc, Color clr1, Color clr2)
{
	Status st = GenericError;
	
	Pen pen1(clr1, 1);
	Pen pen2(clr2, 1);
	st = pen2.SetDashStyle(DashStyleDot);
	st = g->DrawRectangle(&pen1, rc);
	st = g->DrawRectangle(&pen2, rc);
	
	return st;
}// Draw_OutLine

// MIMECLSID擾
int GetEncoderClsid(const WCHAR* format, CLSID* pClsid)
{
	UINT num  = 0; // number of image encoders
	UINT size = 0; // size of the image encoder array in bytes
	
	ImageCodecInfo* pImageCodecInfo = NULL;
	
	GetImageEncodersSize(&num, &size);
	if(size == 0)
		return -1; // Failure
	
	pImageCodecInfo = (ImageCodecInfo*)(malloc(size));
	if(pImageCodecInfo == NULL)
		return -1; // Failure
	
	GetImageEncoders(num, size, pImageCodecInfo);
	
	for(UINT j = 0; j < num; ++j)
	{
		if( wcscmp(pImageCodecInfo[j].MimeType, format) == 0 )
		{
			*pClsid = pImageCodecInfo[j].Clsid;
			free(pImageCodecInfo);
			return j; // Success
		}
	}
	
	free(pImageCodecInfo);
	return -1; // Failure
}// GetEncoderClsid
